/*
 * Intel ACPI Component Architecture
 * AML Disassembler version 20100528
 *
 * Disassembly of SSDT5.dat, Mon Jun 27 13:05:35 2011
 *
 *
 * Original Table Header:
 *     Signature        "SSDT"
 *     Length           0x000011B9 (4537)
 *     Revision         0x01
 *     Checksum         0x93
 *     OEM ID           "Sony"
 *     OEM Table ID     "VAIO"
 *     OEM Revision     0x20110425 (537986085)
 *     Compiler ID      "ACPI"
 *     Compiler Version 0x00040000 (262144)
 */
DefinitionBlock ("SSDT5.aml", "SSDT", 1, "Sony", "VAIO", 0x20110425)
{
    External (ASLB, MethodObj)    // 1 Arguments
    External (LIDS, MethodObj)    // 0 Arguments
    External (DSEN)
    External (PWRS, IntObj)
    External (NDID)
    External (DID7)
    External (DID6)
    External (DID5)
    External (DID4)
    External (DID3)
    External (DID2)
    External (DID1)
    External (PEBS)
    External (SGMD)
    External (AMDA, MethodObj)    // 1 Arguments
    External (\XBAS, MethodObj)    // 1 Arguments
    External (\ECON, IntObj)
    External (\_SB_.PCI0.GFX0, DeviceObj)
    External (\_SB_.PCI0.GFX0._DOD, IntObj)
    External (\_SB_.PCI0.GFX0.CLID)
    External (\_SB_.PCI0.GFX0.AINT, MethodObj)    // 2 Arguments
    External (\_SB_.PCI0.GFX0.GHDS, MethodObj)    // 1 Arguments
    External (\_SB_.PCI0.GFX0.GLID, MethodObj)    // 1 Arguments
    External (\_SB_.PCI0.PEG0.PEGP, DeviceObj)
    External (\_SB_.PCI0.GFX0.DD08._ADR, IntObj)
    External (\_SB_.PCI0.GFX0.DD07._ADR, IntObj)
    External (\_SB_.PCI0.GFX0.DD06._ADR, IntObj)
    External (\_SB_.PCI0.GFX0.DD05._ADR, IntObj)
    External (\_SB_.PCI0.GFX0.DD04._ADR, IntObj)
    External (\_SB_.PCI0.GFX0.DD03._ADR, IntObj)
    External (\_SB_.PCI0.GFX0.DD02._BCM, IntObj)
    External (\_SB_.PCI0.GFX0.DD02._BQC, IntObj)
    External (\_SB_.PCI0.GFX0.DD02._BCL, IntObj)
    External (\_SB_.PCI0.GFX0.DD02._ADR, IntObj)
    External (\_SB_.PCI0.GFX0.DD01._ADR, IntObj)
    External (\_SB_.PCI0.PEG0.PEGP._ADR)
    External (\_SB_.PCI0.LPCB.H_EC.LSTE)
    External (\_SB_.PCI0.LPCB.H_EC.SCAN)
    External (\_SB_.PCI0.LPCB.SNC_.SNNE, MethodObj)    // 1 Arguments
    External (\_SB_.PCI0.LPCB.SNC_.EVRS)

    Scope (\_SB.PCI0.PEG0.PEGP)
    {
        OperationRegion (GPIO, SystemIO, 0x0500, 0x60)
        Field (GPIO, ByteAcc, Lock, Preserve)
        {
                    Offset (0x0C), 
                ,   17, 
            PO17,   1, 
                    Offset (0x38), 
                ,   3, 
            PO35,   1
        }
    }

    Scope (\_SB.PCI0.GFX0)
    {
        Method (_DSM, 4, Serialized)
        {
            Store (And (Arg2, 0xFF), Local0)
            If (LEqual (Arg0, Buffer (0x10)
                    {
                        /* 0000 */    0xD3, 0x73, 0xD8, 0x7E, 0xD0, 0xC2, 0x4F, 0x4E, 
                        /* 0008 */    0xA8, 0x54, 0x0F, 0x13, 0x17, 0xB0, 0x1C, 0x2C
                    }))
            {
                If (LEqual (Arg2, Zero))
                {
                    If (LEqual (PXMS, One))
                    {
                        Return (Buffer (0x04)
                        {
                            0x01, 0x00, 0x00, 0x00
                        })
                    }

                    Return (Buffer (0x04)
                    {
                        0x03, 0x00, 0x00, 0x00
                    })
                }

                If (LEqual (Arg2, One))
                {
                    Return (Package (0x08)
                    {
                        0x07, 
                        Package (0x02)
                        {
                            0x80010100, 
                            Buffer (0x04)
                            {
                                0x01, 0x03, 0x03, 0x00
                            }
                        }, 

                        Package (0x02)
                        {
                            0x80010400, 
                            Buffer (0x04)
                            {
                                0x02, 0x03, 0x03, 0x00
                            }
                        }, 

                        Package (0x02)
                        {
                            0x80010300, 
                            Buffer (0x04)
                            {
                                0x08, 0x03, 0x03, 0x03
                            }
                        }, 

                        Package (0x02)
                        {
                            0x80010301, 
                            Buffer (0x04)
                            {
                                0x04, 0x03, 0x03, 0x03
                            }
                        }, 

                        Package (0x02)
                        {
                            0x80010302, 
                            Buffer (0x04)
                            {
                                0x05, 0x03, 0x03, 0x03
                            }
                        }, 

                        Package (0x02)
                        {
                            0x80010303, 
                            Buffer (0x04)
                            {
                                0x0A, 0x03, 0x03, 0x03
                            }
                        }, 

                        Package (0x02)
                        {
                            0x80010304, 
                            Buffer (0x04)
                            {
                                0x06, 0x03, 0x03, 0x03
                            }
                        }
                    })
                }

                Return (One)
            }

            Return (One)
        }

        OperationRegion (APXM, SystemMemory, AMDA (0x00010400), Field (APXM, AnyAcc, NoLock, Preserve)
            {
                APSG,   128, 
                APSZ,   32, 
                APVR,   32, 
                        Offset (0x100), 
                APXA,   32, 
                RVBS,   32, 
                TVBO,   32, 
                PXEN,   8, 
                        Offset (0x180), 
                NTLE,   16, 
                TLE1,   16, 
                TLE2,   16, 
                TLE3,   16, 
                TLE4,   16, 
                TLE5,   16, 
                TLE6,   16, 
                TLE7,   16, 
                TLE8,   16, 
                TLE9,   16, 
                TL10,   16, 
                TL11,   16, 
                TL12,   16, 
                TL13,   16, 
                TL14,   16, 
                TL15,   16, 
                        Offset (0x200), 
                TGXA,   16, 
                AGXA,   16, 
                GSTP,   8, 
                PXMS,   8, 
                FDSS,   8, 
                DISM,   8, 
                        Offset (0x210), 
                DSWR,   8, 
                EMDR,   8, 
                TSTR,   8, 
                FPSR,   8, 
                SPSR,   8, 
                DCFR,   8, 
                        Offset (0x230), 
                TSTG,   8, 
                TSSI,   8, 
                FPTG,   8, 
                FPSI,   8, 
                SPWS,   8, 
                        Offset (0x250), 
                SUPD,   16, 
                CACD,   16, 
                CCND,   16, 
                NACD,   16, 
                TLST,   8, 
                LDST,   8, 
                        Offset (0x3C0), 
                TVSD,   8, 
                EXPM,   8, 
                BPSD,   16, 
                BSPD,   16, 
                TLSN,   16, 
                        Offset (0x400), 
                RBF1,   262144, 
                RBF2,   262144
            })
        OperationRegion (PRT0, SystemIO, 0x80, 0x04)
        Field (PRT0, DWordAcc, Lock, Preserve)
        {
            P80H,   32
        }

        Method (ATPX, 2, Serialized)
        {
            If (LEqual (Arg0, Zero))
            {
                Name (TMP1, Buffer (0x0100)
                {
                    0x00
                })
                CreateWordField (TMP1, Zero, F0SS)
                CreateWordField (TMP1, 0x02, F0IV)
                CreateDWordField (TMP1, 0x04, F0SF)
                Store (0x08, F0SS)
                Store (One, F0IV)
                Store (0xBB, F0SF)
                If (LEqual (PXMS, One))
                {
                    Store (0x33, F0SF)
                }

                If (LEqual (And (FDSS, 0x02), 0x02))
                {
                    And (F0SF, 0xFFFFFFFD, F0SF)
                }

                If (LEqual (And (FDSS, One), One))
                {
                    And (F0SF, 0xFFFFFFFE, F0SF)
                    Or (F0SF, 0x02, F0SF)
                }

                Return (TMP1)
            }

            If (LEqual (Arg0, One))
            {
                Name (TMP2, Buffer (0x0100)
                {
                    0x00
                })
                CreateWordField (TMP2, Zero, F1SS)
                CreateDWordField (TMP2, 0x02, F1VM)
                CreateDWordField (TMP2, 0x06, F1FG)
                Store (0x0A, F1SS)
                If (LEqual (PXMS, Zero))
                {
                    Store (0x40, F1VM)
                    Store (0x40, F1FG)
                }
                Else
                {
                    Store (Zero, F1VM)
                    Store (Zero, F1FG)
                    If (LEqual (And (FDSS, 0x02), 0x02))
                    {
                        Store (0x80, F1VM)
                        Store (0x80, F1FG)
                    }
                }

                Return (TMP2)
            }

            If (LEqual (Arg0, 0x02))
            {
                CreateWordField (Arg1, Zero, FN2S)
                CreateByteField (Arg1, 0x02, DGPR)
                If (LEqual (DGPR, Zero))
                {
                    GLSC ()
                    \_SB.PCI0.PEG0.PEGP._OFF ()
                    GLSR ()
                    Store (Zero, SGMD)
                }

                If (LEqual (DGPR, One))
                {
                    GLSC ()
                    \_SB.PCI0.PEG0.PEGP._ON ()
                    GLSR ()
                    Store (One, SGMD)
                }

                Return (Zero)
            }

            If (LEqual (Arg0, 0x05))
            {
                CreateWordField (Arg1, Zero, FN5S)
                CreateWordField (Arg1, 0x02, TGFX)
                Store (TGFX, TGXA)
                Store (One, GSTP)
                Return (Zero)
            }

            If (LEqual (Arg0, 0x06))
            {
                CreateWordField (Arg1, Zero, FN6S)
                CreateWordField (Arg1, 0x02, AGFX)
                Store (AGFX, AGXA)
                Store (Zero, GSTP)
                Store (0xCC, P80H)
                Store (0x02, \_SB.PCI0.LPCB.SNC.EVRS)
                \_SB.PCI0.LPCB.SNC.SNNE (0x0146)
                Return (Zero)
            }

            Return (Zero)
        }

        Method (ATRM, 2, Serialized)
        {
            Store (Arg0, Local0)
            Store (Arg1, Local1)
            If (LGreater (Local1, 0x1000))
            {
                Store (0x1000, Local1)
            }

            If (LGreater (Local0, 0x00010000))
            {
                Return (Buffer (Local1)
                {
                    0x00
                })
            }

            If (LGreater (Local0, RVBS))
            {
                Return (Buffer (Local1)
                {
                    0x00
                })
            }

            Multiply (Local1, 0x08, Local3)
            Name (ROM1, Buffer (0x8000)
            {
                0x00
            })
            Name (ROM2, Buffer (Local1)
            {
                0x00
            })
            If (LLess (Local0, 0x8000))
            {
                Store (RBF1, ROM1)
            }
            Else
            {
                Subtract (Local0, 0x8000, Local0)
                Store (RBF2, ROM1)
            }

            Multiply (Local0, 0x08, Local2)
            CreateField (ROM1, Local2, Local3, TMPB)
            Store (TMPB, ROM2)
            Return (ROM2)
        }
    }

    Name (BDFR, 0x000F804C)
    OperationRegion (GPCR, SystemMemory, Or (PEBS, BDFR, BDFR), One)
    Field (GPCR, AnyAcc, NoLock, Preserve)
    {
        GPCT,   1
    }

    Name (GPLS, Zero)
    OperationRegion (APMR, SystemIO, 0xB2, 0x02)
    Field (APMR, WordAcc, NoLock, Preserve)
    {
        APMC,   8, 
        APMS,   8
    }

    Method (GLSC, 0, Serialized)
    {
        Store (GPCT, GPLS)
        If (LEqual (GPCT, One))
        {
            Store (0xFF, APMS)
            Store (Zero, GPCT)
        }
    }

    Method (GLSR, 0, Serialized)
    {
        Store (GPLS, GPCT)
    }

    Method (IDAB, 0, Serialized)
    {
        Store (0x80010100, DID1)
        Store (0x80010400, DID2)
        Store (0x80010300, DID3)
        Store (0x80010301, DID4)
        Store (0x80010302, DID5)
        Store (0x80010303, DID6)
        Store (0x80010304, DID7)
        Store (0x07, NDID)
    }

    Method (HGAS, 0, Serialized)
    {
        If (PWRS)
        {
            Store (One, \_SB.PCI0.GFX0.SPWS)
        }
        Else
        {
            Store (0x02, \_SB.PCI0.GFX0.SPWS)
        }

        If (LNotEqual (\_SB.PCI0.GFX0.GSTP, One))
        {
            Store (One, \_SB.PCI0.GFX0.SPSR)
            Notify (\_SB.PCI0.GFX0, 0x81)
        }
    }

    Method (HBRT, 1, Serialized)
    {
        If (And (0x04, DSEN))
        {
            If (LEqual (Arg0, 0x04))
            {
                Notify (\_SB.PCI0.PEG0.PEGP.DD02, 0x87)
            }

            If (LEqual (Arg0, 0x03))
            {
                Notify (\_SB.PCI0.PEG0.PEGP.DD02, 0x86)
            }
        }
    }

    Method (HLSE, 0, Serialized)
    {
        If (LNotEqual (\_SB.PCI0.GFX0.GSTP, One))
        {
            If (LEqual (\_SB.PCI0.GFX0.AGXA, Zero))
            {
                \_SB.PCI0.GFX0.GLID (LIDS ())
            }
        }
    }

    Method (HDSE, 1, Serialized)
    {
        If (LNotEqual (\_SB.PCI0.GFX0.GSTP, One))
        {
            If (LEqual (\_SB.PCI0.GFX0.AGXA, Zero))
            {
                \_SB.PCI0.GFX0.GHDS (Arg0)
            }
            Else
            {
                Store (One, \_SB.PCI0.GFX0.DSWR)
                Subtract (\_SB.PCI0.LPCB.H_EC.SCAN, 0x3A, \_SB.PCI0.GFX0.TLST)
                Notify (\_SB.PCI0.GFX0, 0x81)
            }
        }
    }

    Method (HPFS, 0, Serialized)
    {
        If (LNotEqual (\_SB.PCI0.GFX0.GSTP, One))
        {
            If (LEqual (\_SB.PCI0.GFX0.AGXA, Zero))
            {
                \_SB.PCI0.GFX0.AINT (0x02, Zero)
            }
            Else
            {
                Store (One, \_SB.PCI0.GFX0.EMDR)
                If (LEqual (\_SB.PCI0.GFX0.EXPM, 0x02))
                {
                    Store (Zero, \_SB.PCI0.GFX0.EXPM)
                }
                Else
                {
                    Increment (\_SB.PCI0.GFX0.EXPM)
                }

                Notify (\_SB.PCI0.GFX0, 0x81)
            }
        }
    }

    Method (HGLS, 0, Serialized)
    {
        If (LNotEqual (\_SB.PCI0.GFX0.GSTP, One))
        {
            If (LEqual (\_SB.PCI0.GFX0.AGXA, Zero))
            {
                If (\_SB.PCI0.GFX0.GLID (LIDS ()))
                {
                    Or (0x80000000, \_SB.PCI0.GFX0.CLID, \_SB.PCI0.GFX0.CLID)
                }
            }
        }
    }

    Method (FPED, 0, NotSerialized)
    {
        OperationRegion (IGDM, SystemMemory, ASLB (0x2000), Field (IGDM, AnyAcc, NoLock, Preserve)
            {
                        Offset (0x1C04), 
                DDCH,   1024
            })
    }

    Method (PDCC, 0, NotSerialized)
    {
        Store (One, \_SB.PCI0.GFX0.DCFR)
        Notify (\_SB.PCI0.GFX0, 0x81)
    }

    Method (PXPW, 0, Serialized)
    {
        If (PWRS)
        {
            Store (One, \_SB.PCI0.GFX0.SPWS)
        }
        Else
        {
            Store (0x02, \_SB.PCI0.GFX0.SPWS)
        }
    }

    Scope (\_SB.PCI0.GFX0)
    {
        Method (ATIF, 2, Serialized)
        {
            If (LEqual (Arg0, Zero))
            {
                Name (TMP0, Buffer (0x0100)
                {
                    0x00
                })
                CreateWordField (TMP0, Zero, F0SS)
                CreateWordField (TMP0, 0x02, F0IV)
                CreateDWordField (TMP0, 0x04, F0SN)
                CreateDWordField (TMP0, 0x08, F0SF)
                Store (0x0C, F0SS)
                Store (One, F0IV)
                Store (0x51, F0SN)
                Store (0x07, F0SF)
                Return (TMP0)
            }

            If (LEqual (Arg0, One))
            {
                Name (TMP1, Buffer (0x0100)
                {
                    0x00
                })
                CreateWordField (TMP1, Zero, F1SS)
                CreateDWordField (TMP1, 0x02, F1VF)
                CreateDWordField (TMP1, 0x06, F1FG)
                Store (0x0A, F1SS)
                Store (0x03, F1VF)
                Store (One, F1FG)
                Return (TMP1)
            }

            If (LEqual (Arg0, 0x02))
            {
                Name (TMP2, Buffer (0x0100)
                {
                    0x00
                })
                CreateWordField (TMP2, Zero, F2SS)
                CreateDWordField (TMP2, 0x02, F2PR)
                CreateByteField (TMP2, 0x06, F2EM)
                CreateByteField (TMP2, 0x07, F2TG)
                CreateByteField (TMP2, 0x08, F2SI)
                CreateByteField (TMP2, 0x09, F2FG)
                CreateByteField (TMP2, 0x0A, F2FI)
                CreateByteField (TMP2, 0x0B, F2SP)
                Store (0x0A, F2SS)
                Name (STS2, Zero)
                Or (DSWR, STS2, STS2)
                Store (STS2, F2PR)
                Store (Zero, DSWR)
                Return (TMP2)
            }

            If (LEqual (Arg0, 0x03))
            {
                Name (TMP3, Buffer (0x0100)
                {
                    0x00
                })
                CreateWordField (TMP3, Zero, F3SS)
                CreateWordField (TMP3, 0x02, F3SD)
                CreateWordField (Arg1, Zero, AI3S)
                CreateWordField (Arg1, 0x02, SLDS)
                CreateWordField (Arg1, 0x04, CODS)
                Store (SLDS, CACD)
                Store (CODS, CCND)
                If (\ECON)
                {
                    If (LEqual (\_SB.PCI0.LPCB.H_EC.LSTE, One))
                    {
                        Or (CCND, One, CCND)
                    }
                }

                Store (0x04, F3SS)
                Store (COTA (CACD), TLSN)
                Store (NTLE, Local0)
                While (Local0)
                {
                    Store (NATL (TLSN), Local1)
                    If (LNotEqual (Local1, Zero))
                    {
                        If (LEqual (And (Local1, CCND), Local1))
                        {
                            Store (One, Local0)
                        }
                    }

                    Decrement (Local0)
                    Increment (TLSN)
                    If (LGreaterEqual (TLSN, NTLE))
                    {
                        Store (One, TLSN)
                    }
                }

                Store (Local1, NACD)
                Store (NACD, F3SD)
                Return (TMP3)
            }

            Return (Zero)
        }

        Method (COTA, 1, NotSerialized)
        {
            If (LNotEqual (NTLE, Zero))
            {
                If (LEqual (TLE1, Arg0))
                {
                    Return (One)
                }

                If (LEqual (TLE2, Arg0))
                {
                    Return (0x02)
                }

                If (LEqual (TLE3, Arg0))
                {
                    Return (0x03)
                }

                If (LEqual (TLE4, Arg0))
                {
                    Return (0x04)
                }

                If (LEqual (TLE5, Arg0))
                {
                    Return (0x05)
                }

                If (LEqual (TLE6, Arg0))
                {
                    Return (0x06)
                }

                If (LEqual (TLE7, Arg0))
                {
                    Return (0x07)
                }

                If (LEqual (TLE8, Arg0))
                {
                    Return (0x08)
                }

                If (LEqual (TLE9, Arg0))
                {
                    Return (0x09)
                }

                If (LEqual (TL10, Arg0))
                {
                    Return (0x0A)
                }

                If (LEqual (TL11, Arg0))
                {
                    Return (0x0B)
                }

                If (LEqual (TL12, Arg0))
                {
                    Return (0x0C)
                }

                If (LEqual (TL13, Arg0))
                {
                    Return (0x0D)
                }

                If (LEqual (TL14, Arg0))
                {
                    Return (0x0E)
                }

                If (LEqual (TL15, Arg0))
                {
                    Return (0x0F)
                }
            }

            Return (Zero)
        }

        Method (NATL, 1, NotSerialized)
        {
            If (LNotEqual (NTLE, Zero))
            {
                If (LEqual (Arg0, One))
                {
                    Return (TLE2)
                }

                If (LEqual (Arg0, 0x02))
                {
                    Return (TLE3)
                }

                If (LEqual (Arg0, 0x03))
                {
                    Return (TLE4)
                }

                If (LEqual (Arg0, 0x04))
                {
                    Return (TLE5)
                }

                If (LEqual (Arg0, 0x05))
                {
                    Return (TLE6)
                }

                If (LEqual (Arg0, 0x06))
                {
                    Return (TLE7)
                }

                If (LEqual (Arg0, 0x07))
                {
                    Return (TLE8)
                }

                If (LEqual (Arg0, 0x08))
                {
                    Return (TLE9)
                }

                If (LEqual (Arg0, 0x09))
                {
                    Return (TL10)
                }

                If (LEqual (Arg0, 0x0A))
                {
                    Return (TL11)
                }

                If (LEqual (Arg0, 0x0B))
                {
                    Return (TL12)
                }

                If (LEqual (Arg0, 0x0C))
                {
                    Return (TL13)
                }

                If (LEqual (Arg0, 0x0D))
                {
                    Return (TL14)
                }

                If (LEqual (Arg0, 0x0E))
                {
                    Return (TL15)
                }

                If (LEqual (Arg0, 0x0F))
                {
                    Return (TLE1)
                }
            }

            Return (Zero)
        }
    }

    Scope (\_SB.PCI0.PEG0.PEGP)
    {
        Method (PWRE, 0, Serialized)
        {
            Store (Zero, \_SB.PCI0.PEG0.PEGP.PO17)
            Store (One, \_SB.PCI0.PEG0.PEGP.PO35)
            Sleep (0x96)
            Store (One, \_SB.PCI0.PEG0.PEGP.PO17)
            Sleep (0x64)
        }

        Method (PWRD, 0, Serialized)
        {
            Store (Zero, \_SB.PCI0.PEG0.PEGP.PO17)
            Store (Zero, \_SB.PCI0.PEG0.PEGP.PO35)
        }
    }

    Scope (\_SB.PCI0.PEG0)
    {
        OperationRegion (RPCI, PCI_Config, Zero, 0xF0)
        Field (RPCI, DWordAcc, Lock, Preserve)
        {
                    Offset (0xB0), 
            ASPM,   2, 
                ,   2, 
            LNKD,   1
        }

        OperationRegion (RPCX, SystemMemory, \XBAS (0x8400), Field (RPCX, DWordAcc, NoLock, Preserve)
            {
                        Offset (0x8214), 
                        Offset (0x8216), 
                LNKS,   4
            })
    }

    Scope (\_SB.PCI0.PEG0.PEGP)
    {
        Name (ELCT, Zero)
        Name (HVID, Zero)
        Name (HDID, Zero)
        OperationRegion (PCIS, PCI_Config, Zero, 0x0100)
        Field (PCIS, DWordAcc, Lock, Preserve)
        {
            DVID,   16, 
                    Offset (0x2C), 
            SVID,   16, 
            SDID,   16, 
                    Offset (0x4C), 
            WVID,   16, 
            WDID,   16
        }

        Name (B0D1, Zero)
        OperationRegion (PCAP, SystemMemory, Or (PEBS, 0x8000, B0D1), 0xC0)
        Field (PCAP, DWordAcc, NoLock, Preserve)
        {
                    Offset (0xB0), 
            LCTL,   16
        }

        Method (_INI, 0, NotSerialized)
        {
            Store (Zero, \_SB.PCI0.PEG0.PEGP._ADR)
        }

        Method (_ON, 0, Serialized)
        {
            \_SB.PCI0.PEG0.PEGP.PWRE ()
            Store (Zero, LNKD)
            While (LLess (LNKS, 0x07))
            {
                Sleep (One)
            }

            Store (HVID, WVID)
            Store (HDID, WDID)
            Or (And (ELCT, 0x43), And (LCTL, 0xFFBC), LCTL)
            Notify (\_SB.PCI0.PEG0, Zero)
        }

        Method (_OFF, 0, Serialized)
        {
            Store (LCTL, ELCT)
            Store (SVID, HVID)
            Store (SDID, HDID)
            Store (One, LNKD)
            While (LLess (LNKS, Zero))
            {
                Sleep (One)
            }

            \_SB.PCI0.PEG0.PEGP.PWRD ()
            Notify (\_SB.PCI0.PEG0, Zero)
        }

        Method (_STA, 0, Serialized)
        {
            If (LEqual (\_SB.PCI0.PEG0.PEGP.PO35, One))
            {
                Return (0x0F)
            }

            Return (Zero)
        }

        Method (_DOD, 0, NotSerialized)
        {
            Return (\_SB.PCI0.GFX0._DOD)
        }

        Device (DD01)
        {
            Method (_ADR, 0, Serialized)
            {
                Return (\_SB.PCI0.GFX0.DD01._ADR)
            }

            Method (_DOS, 1, NotSerialized)
            {
            }
        }

        Device (DD02)
        {
            Method (_ADR, 0, Serialized)
            {
                Return (\_SB.PCI0.GFX0.DD02._ADR)
            }

            Method (_DOS, 1, NotSerialized)
            {
            }

            Method (_BCL, 0, NotSerialized)
            {
                Return (\_SB.PCI0.GFX0.DD02._BCL)
            }

            Method (_BQC, 0, NotSerialized)
            {
                Return (\_SB.PCI0.GFX0.DD02._BQC)
            }

            Method (_BCM, 1, NotSerialized)
            {
                Return (\_SB.PCI0.GFX0.DD02._BCM)
                Arg0
            }
        }

        Device (DD03)
        {
            Method (_ADR, 0, Serialized)
            {
                Return (\_SB.PCI0.GFX0.DD03._ADR)
            }

            Method (_DOS, 1, NotSerialized)
            {
            }
        }

        Device (DD04)
        {
            Method (_ADR, 0, Serialized)
            {
                Return (\_SB.PCI0.GFX0.DD04._ADR)
            }

            Method (_DOS, 1, NotSerialized)
            {
            }
        }

        Device (DD05)
        {
            Method (_ADR, 0, Serialized)
            {
                Return (\_SB.PCI0.GFX0.DD05._ADR)
            }

            Method (_DOS, 1, NotSerialized)
            {
            }
        }

        Device (DD06)
        {
            Method (_ADR, 0, Serialized)
            {
                Return (\_SB.PCI0.GFX0.DD06._ADR)
            }

            Method (_DOS, 1, NotSerialized)
            {
            }
        }

        Device (DD07)
        {
            Method (_ADR, 0, Serialized)
            {
                Return (\_SB.PCI0.GFX0.DD07._ADR)
            }

            Method (_DOS, 1, NotSerialized)
            {
            }
        }

        Device (DD08)
        {
            Method (_ADR, 0, Serialized)
            {
                Return (\_SB.PCI0.GFX0.DD08._ADR)
            }

            Method (_DOS, 1, NotSerialized)
            {
            }
        }
    }
}

